using System;

namespace OPP_Modeling
{
  /// <summary>
  /// Pouziti destructoru
  /// - pouzij destruktor, pokud potrebujes manualne uvolnit pamet
  /// - neni treba implementovat destruktor
  /// - implementovat IDisposable interface
  /// - zdedene destruktory jsou volane v opacnem poradi nez konstruktory
  /// - Napr. formulare vyuzivaji hodne "Resources"
  /// </summary>
  public class Porsche : Car, IDisposable
  {
    ~Porsche() //destructor
    {
      Dispose(false);
    }

    public void Dispose() // used as idiom
    {
      Dispose(true);
      // Tento objekt bude uvolnen Dispose metodou.
      // Mame volat GC.SupressFinalize k upozorneni GC
      // ze tento objekt je uvolnen manualne
      // a zabranit opakovanemu volani uvolnovani.
      GC.SuppressFinalize(this);
    }

    protected virtual void Dispose(bool disposing)
    {
      if (disposing)
      {
        // Objekt je pripraven k uvolneni Dispose methodou
        // uvolnit spravovane (managed) zdroje.
      }

      // uvolnit unmanaged ressources.
    }
  }
}
