namespace OPP_Modeling
{
  /// <summary>
  /// Base trida pro vsechny dopravni prostredky.
  /// Nelze inicializovat, je abstraktni.
  /// Dedi od objectu
  /// </summary>
  public abstract class Vehicle
  {
    #region fields
    private string name; //fields
    private string manufacturer;
    private int created;
    #endregion

    #region properties
    public int Created
    {
      get { return created; }
      set { created = value; }
    }

    public string Manufacturer
    {
      get { return manufacturer; }
      set { manufacturer = value; }
    }

    public string Name
    {
      get { return name; }
      set { name = value; }
    }

    #endregion

    //abstract - bez implementace. Odvozene tridy musi implementovat tuto metodu
    internal abstract string VehicleType();

    //jako abstract + base implementation
    public virtual string VehicleTypeVirtual()
    {
      return "base virtual implementation";
    }

    //viditelna pouze k odvozenych typech
    protected string VehicleTypeProtected()
    {
      return "parent implementation";
    }
  }
}
