using System;

namespace events
{
  /// <summary>
  /// 03b - events
  /// - delegat je ukazatel na metodu
  /// - event je vlastnost typu ukazatel na kolekci metod
  /// - zachyceni udalosti je treba zaregistrovat posluchace (event handler)
  /// - lze pouzit pouze += nebo -= operatory
  /// - interne je kolekci metod registrovanych k zavolani, pri vyvolani udalosti.
  /// Bohuzel nemame pristup k tomuto listu, takze nevime, kolik a jakych eventhandleru je registrovanych.
  /// </summary>
  internal class Program
  {
    private static void Main()
    {
      TraficLight tl = new TraficLight(); //initialize and start
      tl.StatusChange += new LightHandler(tl_StatusChange); //register delegate

      Console.ReadKey();
    }

    /// <summary>
    /// Event handler pro Status changed event.
    /// </summary>
    private static void tl_StatusChange(Light sender)
    {
      Console.ForegroundColor= sender.Color;
      Console.WriteLine(DateTime.Now);
    }
  }
}
